
#############################################################################################################################
#   filename:morseTranslate.py                                                       
#   created: 2023-02-11                                                              
#   import your librarys below                                                    
#############################################################################################################################

class morseTranslate:
    MORSE_CODE_DICT = {
        'A': '.-', 'B': '-...', 'C': '-.-.', 'D': '-..', 'E': '.',
        'F': '..-.', 'G': '--.', 'H': '....', 'I': '..', 'J': '.---',
        'K': '-.-', 'L': '.-..', 'M': '--', 'N': '-.', 'O': '---',
        'P': '.--.', 'Q': '--.-', 'R': '.-.', 'S': '...', 'T': '-',
        'U': '..-', 'V': '...-', 'W': '.--', 'X': '-..-', 'Y': '-.--',
        'Z': '--..', '1': '.----', '2': '..---', '3': '...--', '4': '....-',
        '5': '.....', '6': '-....', '7': '--...', '8': '---..', '9': '----.',
        '0': '-----', ',': '--..--', '.': '.-.-.-', '?': '..--..', '/': '-..-.',
        '-': '-....-', '(': '-.--.', ')': '-.--.-', 'Á': '.--.-', 'É': '..-..',
        'Í': '..', 'Ó': '---', 'Ú': '..--', 'Ç': '-.-..', '!': '-.-.--',
        ':': '---...', ';': '-.-.-.', '@': '.--.-.'
    }

    def to_morse(self, message):
        message = message.upper()
        morse = [self.MORSE_CODE_DICT.get(letter, ' ') for letter in message]
        return ' '.join(morse)

    def to_text(self, message):
        message = message.split(' ')
        text = [list(self.MORSE_CODE_DICT.keys())[list(self.MORSE_CODE_DICT.values()).index(morse)]
                if morse != '' else ' ' for morse in message]
        return ''.join(text)